#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>

void pause(int *Pointeursur_continuer);

int main(int argc, char *argv[])
{

    //Initialisation de la SDL
    SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO);
    TTF_Init();


    SDL_WM_SetCaption("ReglePSP for linux", NULL);


	//Initialisation des image
	SDL_Surface *ecran = NULL;
	SDL_Surface *background_orig = NULL;
	SDL_Surface *background = NULL;
	SDL_Surface *background2 = NULL;
	SDL_Surface *background3 = NULL;
	SDL_Surface *background4 = NULL;
	SDL_Surface *texteX = NULL;
	SDL_Surface *texteY = NULL;
	SDL_Surface *backgroundopacity = NULL;
	SDL_Surface *myimageopacity = NULL;
	SDL_Surface *myimage_orig = NULL;
	SDL_Surface *myimage = NULL;
	SDL_Surface *myimage2 = NULL;
	SDL_Surface *myimage3 = NULL;
	SDL_Surface *myimage4 = NULL;
	SDL_Surface *backblanc = NULL;


	//Police et oculeur
	TTF_Font *police = NULL;
	SDL_Color couleurNoire = {0, 0, 0}, couleurBlanche = {255, 255, 255};
	police = TTF_OpenFont("Vera.ttf", 12);


	//Chargement des images
	ecran = SDL_SetVideoMode(480, 272, 32, SDL_HWSURFACE | SDL_RESIZABLE | SDL_DOUBLEBUF);
	background_orig = IMG_Load("img/background.png");
	background = IMG_Load("img/background.png");
	background2 = IMG_Load("img/background2.png");
	background3 = IMG_Load("img/background3.png");
	background4 = IMG_Load("img/background4.png");
	backblanc = IMG_Load("img/system/fond.png");
	myimage_orig = IMG_Load("img/monimage.png");
	myimage = IMG_Load("img/monimage.png");
	myimage2 = IMG_Load("img/monimage2.png");
	myimage3 = IMG_Load("img/monimage3.png");
	myimage4 = IMG_Load("img/monimage4.png");


	//Initialisation des Positions des images
	SDL_Rect background_position;
	background_position.x = 0;
	background_position.y = 0;
	
	SDL_Rect curseur_position;
	curseur_position.x = 240;
	curseur_position.y = 65;
	
	SDL_Rect texteX_position;
	texteX_position.x = 5;
	texteX_position.y = 5;
	
	SDL_Rect texteY_position;
	texteY_position.x = 5;
	texteY_position.y = 20;

	SDL_Rect backgroundopacity_position;
	backgroundopacity_position.x = 5;
	backgroundopacity_position.y = 236;
	
	SDL_Rect myimageopacity_position;
	myimageopacity_position.x = 5;
	myimageopacity_position.y = 251;

	SDL_Rect orig_position;
	orig_position.x = 0;
	orig_position.y = 0;

	SDL_Rect alpha_position;
	alpha_position.x = 0;
	alpha_position.y = 250;

	int continuer = 1;
	int rouge = 0;
	int vert = 0;
	int bleu = 255;
	char speed = 1;
	int counter_color = 0;
	char appuis = 0;
	char choix_img = 1;
	char background_modify = 0;
	int opacite_myimage = NULL;
	int opacite_background = NULL;
	opacite_myimage = 255;
	opacite_background = 255;

	char x_coord[20] = "";
	char y_coord[20] = "";
	
	char backgroundopacity_coord[20] = "";
	char myimageopacity_coord[20] = "";

SDL_Event event;

    sprintf(x_coord, "x (image) = %d", curseur_position.x);
    texteX = TTF_RenderText_Shaded(police, x_coord, couleurNoire, couleurBlanche);
    sprintf(y_coord, "y (image) = %d", curseur_position.y);
    texteY = TTF_RenderText_Shaded(police, y_coord, couleurNoire, couleurBlanche);

    sprintf(backgroundopacity_coord, "Background opacity = %d", opacite_background);
    backgroundopacity = TTF_RenderText_Shaded(police, backgroundopacity_coord, couleurNoire, couleurBlanche);
    sprintf(myimageopacity_coord, "Image opacity = %d", opacite_myimage);
    myimageopacity = TTF_RenderText_Shaded(police, myimageopacity_coord, couleurNoire, couleurBlanche);

SDL_EnableKeyRepeat(10, 10);

	while(continuer)
	{

		SDL_WaitEvent(&event);
		if (appuis <= 0) (appuis = 0);

		//Permet d'interchanger les image
		if (event.key.keysym.sym == SDLK_a && appuis == 0)
		{
		choix_img++;
		appuis = 6;
		}
		//Choisir entre déplacer le background ou l'image
		else if (event.key.keysym.sym == SDLK_SPACE && appuis == 0)
		{
		background_modify++;
		appuis = 6;
		}		
		else appuis = (appuis - 1);


		if (background_modify >= 2) ( background_modify = 0);

		
		//Le choix des images
		if (background_modify == 0)
		{
			if (choix_img == 1)
			{
			myimage = myimage_orig;
			}
			else if (choix_img == 2)
			{
				if (myimage2) (myimage = myimage2);
				else if (!myimage2) (choix_img = 3 );
			}
			else if (choix_img == 3)
			{
			if (myimage3) (myimage = myimage3);
			else if (!myimage3) (choix_img = 4);
			}
			else if (choix_img == 4)
			{
				if (myimage4) (myimage = myimage4);
				else if (!myimage4) (choix_img = 5);
			}
			else if (choix_img >= 5)
			{
			choix_img = 1;
			}
		}
		else if (background_modify == 1)
		{
			if (choix_img == 1)
			{
			background = background_orig;
			}
			else if (choix_img == 2)
			{
				if (background2) (background = background2);
				else if (!background2) (choix_img = 3 );
			}
			else if (choix_img == 3)
			{
			if (background3) (background = background3);
			else if (!background3) (choix_img = 4);
			}
			else if (choix_img == 4)
			{
				if (background4) (background = background4);
				else if (!background4) (choix_img = 5);
			}
			else if (choix_img >= 5)
			{
			choix_img = 1;
			}
		}


		//Si on souhaite déplacer l'image
		if (background_modify == 0)
		{
		if (event.key.keysym.sym == SDLK_d) 
		{
		(curseur_position.x+=speed);
		sprintf(x_coord, "x (image) = %d", curseur_position.x);
		SDL_FreeSurface(texteX);
		texteX = TTF_RenderText_Shaded(police, x_coord, couleurNoire, couleurBlanche);
		}
		else if (event.key.keysym.sym == SDLK_q) 
		{
		(curseur_position.x-=speed);
		sprintf(x_coord, "x (image) = %d", curseur_position.x);
		SDL_FreeSurface(texteX);
		texteX = TTF_RenderText_Shaded(police, x_coord, couleurNoire, couleurBlanche);
		}
		else if (event.key.keysym.sym == SDLK_z) 
		{
		(curseur_position.y-=speed);
		sprintf(y_coord, "y (image) = %d", curseur_position.y);
		SDL_FreeSurface(texteY);
		texteY = TTF_RenderText_Shaded(police, y_coord, couleurNoire, couleurBlanche);
		}
		else if (event.key.keysym.sym == SDLK_s) 
		{
		(curseur_position.y+=speed);
		sprintf(y_coord, "y (image) = %d", curseur_position.y);
		SDL_FreeSurface(texteY);
		texteY = TTF_RenderText_Shaded(police, y_coord, couleurNoire, couleurBlanche);
		}
		if (event.key.keysym.sym == SDLK_c)
		{
		opacite_myimage-=speed;
		sprintf(myimageopacity_coord, "Image opacity = %d", opacite_myimage);
		SDL_FreeSurface(myimageopacity);
   		myimageopacity = TTF_RenderText_Shaded(police, myimageopacity_coord, couleurNoire, couleurBlanche);
		}
		if (opacite_myimage <= 5) (opacite_myimage = 255);
		SDL_SetAlpha(myimage, SDL_SRCALPHA, opacite_myimage);
		}
		//Si on souhaite déplacer le background
		else if (background_modify == 1)
		{
		if (event.key.keysym.sym == SDLK_d) 
		{
		(background_position.x+=speed);
		sprintf(x_coord, "x (background) = %d", background_position.x);
		SDL_FreeSurface(texteX);
		texteX = TTF_RenderText_Shaded(police, x_coord, couleurNoire, couleurBlanche);
		}
		else if (event.key.keysym.sym == SDLK_q) 
		{
		(background_position.x-=speed);
		sprintf(x_coord, "x (background) = %d", background_position.x);
		SDL_FreeSurface(texteX);
		texteX = TTF_RenderText_Shaded(police, x_coord, couleurNoire, couleurBlanche);
		}
		else if (event.key.keysym.sym == SDLK_z) 
		{
		(background_position.y-=speed);
		sprintf(y_coord, "y (background) = %d", background_position.y);
		SDL_FreeSurface(texteY);
		texteY = TTF_RenderText_Shaded(police, y_coord, couleurNoire, couleurBlanche);
		}
		else if (event.key.keysym.sym == SDLK_s) 
		{
		(background_position.y+=speed);
		sprintf(y_coord, "y (background) = %d", background_position.y);
		SDL_FreeSurface(texteY);
		texteY = TTF_RenderText_Shaded(police, y_coord, couleurNoire, couleurBlanche);
		}
		if (event.key.keysym.sym == SDLK_c)
		{
		opacite_background-=speed;
		sprintf(backgroundopacity_coord, "Background opacity = %d", opacite_background);
		SDL_FreeSurface(backgroundopacity);
    		backgroundopacity = TTF_RenderText_Shaded(police, backgroundopacity_coord, couleurNoire, couleurBlanche);
		}
		if (opacite_background <= 5) (opacite_background = 255);
		SDL_SetAlpha(background, SDL_SRCALPHA, opacite_background);
		}


		//Accélérer la vitesse
		if (event.key.keysym.sym == SDLK_LSHIFT)
		{
		speed = 4;
		}
		//Diminuer la vitesse
		if (event.key.keysym.sym == SDLK_RSHIFT)
		{
		speed = 1;
		}
		
		//On bloque au limite de lécran
		if (curseur_position.y >= 271) (curseur_position.y = 271);
		if (curseur_position.y <= 1) (curseur_position.y = 1);
		if (curseur_position.x >= 479) (curseur_position.x = 479);
		if (curseur_position.x <= 1) (curseur_position.y = 1);
		
		if (texteX_position.y <= 1) (texteX_position.y = 1);
		if (texteX_position.x <= 1) (texteX_position.y = 1);
		if (texteY_position.y <= 16) (texteY_position.y = 16);
		if (texteY_position.x <= 1) (texteY_position.y = 1);

		if (myimageopacity_position.y <= 1) (myimageopacity_position.y = 1);
		if (myimageopacity_position.x <= 1) (myimageopacity_position.y = 1);
		if (backgroundopacity_position.y <= 16) (backgroundopacity_position.y = 16);
		if (backgroundopacity_position.x <= 1) (backgroundopacity_position.y = 1);


	SDL_BlitSurface(backblanc, NULL, ecran, &orig_position);
	SDL_SetAlpha(background, SDL_SRCALPHA, opacite_background);
	SDL_BlitSurface(background, NULL, ecran, &background_position);

	//On déplace l'affichage des coordonnées
	if (event.key.keysym.sym == SDLK_RIGHT)
	{
	texteY_position.x += 5;
	texteX_position.x += 5;
	}
	else if (event.key.keysym.sym == SDLK_LEFT)
	{
	texteY_position.x -= 5;
	texteX_position.x -= 5;
	}
	
	if (event.key.keysym.sym == SDLK_DOWN)
	{
	texteY_position.y += 5;
	texteX_position.y += 5;
	}
	else if (event.key.keysym.sym == SDLK_UP)
	{
	texteY_position.y -= 5;
	texteX_position.y -= 5;
	}	

	//On déplace l'affichage des coordonnées
	if (event.key.keysym.sym == SDLK_m)
	{
	myimageopacity_position.x += 5;
	backgroundopacity_position.x += 5;
	}
	else if (event.key.keysym.sym == SDLK_k)
	{
	myimageopacity_position.x -= 5;
	backgroundopacity_position.x -= 5;
	}
	
	if (event.key.keysym.sym == SDLK_l)
	{
	myimageopacity_position.y += 5;
	backgroundopacity_position.y += 5;
	}
	else if (event.key.keysym.sym == SDLK_o)
	{
	myimageopacity_position.y -= 5;
	backgroundopacity_position.y -= 5;
	}

	//On affiche la valeur de la transparence

	//On affiche le tout
	SDL_BlitSurface(myimage, NULL, ecran, &curseur_position);
	SDL_BlitSurface(texteX, NULL, ecran, &texteX_position);
	SDL_BlitSurface(texteY, NULL, ecran, &texteY_position);
	SDL_BlitSurface(backgroundopacity, NULL, ecran, &backgroundopacity_position);
	SDL_BlitSurface(myimageopacity, NULL, ecran, &myimageopacity_position);
	

	SDL_Flip(ecran);
	pause(&continuer);
	}








SDL_FreeSurface(ecran);
SDL_FreeSurface(backgroundopacity);
SDL_FreeSurface(myimageopacity);
SDL_FreeSurface(background_orig);
SDL_FreeSurface(background);
SDL_FreeSurface(background2);
SDL_FreeSurface(background3);
SDL_FreeSurface(background4);
SDL_FreeSurface(texteX);
SDL_FreeSurface(texteY);
SDL_FreeSurface(myimage_orig);
SDL_FreeSurface(myimage);
SDL_FreeSurface(myimage2);
SDL_FreeSurface(myimage3);
SDL_FreeSurface(myimage4);
SDL_FreeSurface(backblanc);
TTF_CloseFont(police);
TTF_Quit();
SDL_Quit();
return EXIT_SUCCESS;
}















void pause(int *Pointeursur_continuer)
{
    SDL_Event event;

        SDL_WaitEvent(&event);
        switch(event.type)
        {
            case SDL_QUIT:
                *Pointeursur_continuer = 0;
	    case SDL_KEYDOWN:
            switch (event.key.keysym.sym)
            {
                case SDLK_ESCAPE:
                    *Pointeursur_continuer = 0;
                    break;
            }
            break;
        }
}
